# Generated by Django 4.2.1 on 2023-06-08 18:17

import django.db.models.deletion
import lnschema_core._users
from django.db import migrations, models

import lnschema_bionty.ids


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("lnschema_core", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="Species",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=lnschema_bionty.ids.species,
                        max_length=4,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(db_index=True, max_length=64)),
                ("taxon_id", models.IntegerField(db_index=True, unique=True)),
                (
                    "scientific_name",
                    models.CharField(db_index=True, max_length=64, unique=True),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        default=lnschema_core._users.current_user_id,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_core.user",
                    ),
                ),
            ],
            options={
                "managed": True,
            },
        ),
        migrations.CreateModel(
            name="Protein",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=lnschema_bionty.ids.protein,
                        max_length=8,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(db_index=True, max_length=64)),
                ("uniprotkb_id", models.CharField(db_index=True, max_length=10)),
                ("uniprotkb_name", models.CharField(db_index=True, max_length=64)),
                ("synonyms", models.TextField()),
                ("length", models.BigIntegerField()),
                ("gene_symbols", models.TextField()),
                ("gene_synonyms", models.TextField()),
                ("ensembl_transcript_ids", models.TextField()),
                ("ncbi_gene_ids", models.TextField()),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        default=lnschema_core._users.current_user_id,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_core.user",
                    ),
                ),
                (
                    "featuresets",
                    models.ManyToManyField(related_name="proteins", to="lnschema_core.featureset"),
                ),
                (
                    "species",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_bionty.species",
                    ),
                ),
            ],
            options={
                "managed": True,
            },
        ),
        migrations.CreateModel(
            name="Gene",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=lnschema_bionty.ids.gene,
                        max_length=8,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("ensembl_gene_id", models.CharField(db_index=True, max_length=64)),
                ("symbol", models.CharField(db_index=True, max_length=64)),
                ("gene_type", models.CharField(db_index=True, max_length=64)),
                ("description", models.TextField()),
                ("ncbi_gene_id", models.BigIntegerField(db_index=True)),
                ("hgnc_id", models.CharField(db_index=True, max_length=10)),
                ("mgi_id", models.CharField(db_index=True, max_length=11)),
                ("omim_id", models.CharField(db_index=True, max_length=6)),
                ("synonyms", models.TextField()),
                ("version", models.CharField(db_index=True, max_length=64)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        default=lnschema_core._users.current_user_id,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_core.user",
                    ),
                ),
                (
                    "featuresets",
                    models.ManyToManyField(related_name="genes", to="lnschema_core.featureset"),
                ),
                (
                    "species",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_bionty.species",
                    ),
                ),
            ],
            options={
                "managed": True,
            },
        ),
        migrations.CreateModel(
            name="CellMarker",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=lnschema_bionty.ids.cell_marker,
                        max_length=8,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(db_index=True, max_length=64, unique=True)),
                ("ncbi_gene_id", models.CharField(db_index=True, max_length=32)),
                ("gene_symbol", models.CharField(db_index=True, max_length=64)),
                ("gene_name", models.TextField()),
                ("uniprotkb_id", models.CharField(db_index=True, max_length=10)),
                ("synonyms", models.TextField()),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        default=lnschema_core._users.current_user_id,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_core.user",
                    ),
                ),
                (
                    "featuresets",
                    models.ManyToManyField(related_name="cell_markers", to="lnschema_core.featureset"),
                ),
                (
                    "species",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_bionty.species",
                    ),
                ),
            ],
            options={
                "managed": True,
            },
        ),
        migrations.CreateModel(
            name="Tissue",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=lnschema_bionty.ids.tissue,
                        max_length=8,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(db_index=True, max_length=256)),
                ("short_name", models.CharField(db_index=True, max_length=32)),
                ("synonyms", models.TextField()),
                ("ontology_id", models.CharField(db_index=True, max_length=16)),
                ("definition", models.TextField()),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        default=lnschema_core._users.current_user_id,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_core.user",
                    ),
                ),
                (
                    "files",
                    models.ManyToManyField(related_name="tissues", to="lnschema_core.file"),
                ),
            ],
            options={
                "managed": True,
                "unique_together": {("name", "ontology_id")},
            },
        ),
        migrations.CreateModel(
            name="Readout",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=lnschema_bionty.ids.readout,
                        max_length=8,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(db_index=True, max_length=256)),
                ("short_name", models.CharField(db_index=True, max_length=32)),
                ("synonyms", models.TextField()),
                ("ontology_id", models.CharField(db_index=True, max_length=16)),
                ("definition", models.TextField()),
                ("molecule", models.TextField(db_index=True)),
                ("instrument", models.TextField(db_index=True)),
                ("measurement", models.TextField(db_index=True)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        default=lnschema_core._users.current_user_id,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_core.user",
                    ),
                ),
                (
                    "files",
                    models.ManyToManyField(related_name="readouts", to="lnschema_core.file"),
                ),
            ],
            options={
                "managed": True,
                "unique_together": {("name", "ontology_id")},
            },
        ),
        migrations.CreateModel(
            name="Phenotype",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=lnschema_bionty.ids.phenotype,
                        max_length=8,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(db_index=True, max_length=256)),
                ("short_name", models.CharField(db_index=True, max_length=32)),
                ("synonyms", models.TextField()),
                ("ontology_id", models.CharField(db_index=True, max_length=16)),
                ("definition", models.TextField()),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        default=lnschema_core._users.current_user_id,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_core.user",
                    ),
                ),
                (
                    "files",
                    models.ManyToManyField(related_name="phenotypes", to="lnschema_core.file"),
                ),
            ],
            options={
                "managed": True,
                "unique_together": {("name", "ontology_id")},
            },
        ),
        migrations.CreateModel(
            name="Pathway",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=lnschema_bionty.ids.pathway,
                        max_length=8,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(db_index=True, max_length=256)),
                ("short_name", models.CharField(db_index=True, max_length=32)),
                ("synonyms", models.TextField()),
                ("ontology_id", models.CharField(db_index=True, max_length=16)),
                ("definition", models.TextField()),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        default=lnschema_core._users.current_user_id,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_core.user",
                    ),
                ),
                (
                    "featuresets",
                    models.ManyToManyField(related_name="pathways", to="lnschema_core.featureset"),
                ),
                ("genes", models.ManyToManyField(to="lnschema_bionty.gene")),
            ],
            options={
                "managed": True,
                "unique_together": {("name", "ontology_id")},
            },
        ),
        migrations.CreateModel(
            name="Disease",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=lnschema_bionty.ids.disease,
                        max_length=8,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(db_index=True, max_length=256)),
                ("short_name", models.CharField(db_index=True, max_length=32)),
                ("synonyms", models.TextField()),
                ("ontology_id", models.CharField(db_index=True, max_length=16)),
                ("definition", models.TextField()),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        default=lnschema_core._users.current_user_id,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_core.user",
                    ),
                ),
                (
                    "files",
                    models.ManyToManyField(related_name="diseases", to="lnschema_core.file"),
                ),
            ],
            options={
                "managed": True,
                "unique_together": {("name", "ontology_id")},
            },
        ),
        migrations.CreateModel(
            name="CellType",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=lnschema_bionty.ids.cell_type,
                        max_length=8,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(db_index=True, max_length=256)),
                ("short_name", models.CharField(db_index=True, max_length=32)),
                ("synonyms", models.TextField()),
                ("ontology_id", models.CharField(db_index=True, max_length=16)),
                ("definition", models.TextField()),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        default=lnschema_core._users.current_user_id,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_core.user",
                    ),
                ),
                (
                    "files",
                    models.ManyToManyField(related_name="cell_types", to="lnschema_core.file"),
                ),
            ],
            options={
                "managed": True,
                "unique_together": {("name", "ontology_id")},
            },
        ),
        migrations.CreateModel(
            name="CellLine",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=lnschema_bionty.ids.cell_line,
                        max_length=8,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(db_index=True, max_length=256)),
                ("short_name", models.CharField(db_index=True, max_length=32)),
                ("synonyms", models.TextField()),
                ("ontology_id", models.CharField(db_index=True, max_length=16)),
                ("definition", models.TextField()),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        default=lnschema_core._users.current_user_id,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_core.user",
                    ),
                ),
                (
                    "files",
                    models.ManyToManyField(related_name="cell_lines", to="lnschema_core.file"),
                ),
            ],
            options={
                "managed": True,
                "unique_together": {("name", "ontology_id")},
            },
        ),
        migrations.CreateModel(
            name="BiontySource",
            fields=[
                ("id", models.BigAutoField(primary_key=True, serialize=False)),
                (
                    "entity",
                    models.CharField(db_index=True, default=None, max_length=64),
                ),
                (
                    "species",
                    models.CharField(db_index=True, default=None, max_length=64),
                ),
                ("currently_used", models.BooleanField(db_index=True, default=False)),
                ("source_name", models.TextField(blank=True, db_index=True)),
                (
                    "source_key",
                    models.CharField(db_index=True, default=None, max_length=64),
                ),
                (
                    "version",
                    models.CharField(db_index=True, default=None, max_length=64),
                ),
                ("url", models.TextField(blank=True)),
                ("md5", models.TextField(blank=True)),
                ("source_website", models.TextField(blank=True)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        default=lnschema_core._users.current_user_id,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="lnschema_core.user",
                    ),
                ),
            ],
            options={
                "managed": True,
                "unique_together": {("entity", "source_key", "species", "version")},
            },
        ),
    ]
